'use strict';
let generator = require('yeoman-generator');

module.exports = generator.Base.extend({

  constructor: function() {
    generator.Base.apply(this, arguments);

    this.option('skip-install');
  },

  install: function() {

    if(!this.options['skip-install']) {
      this.installDependencies({ bower: false });
    }

    // Run the base react-webpack generator, then run the dispatcher
    this.composeWith(
      'react-webpack',
      {
        options: {
          'skip-install': this.options['skip-install']
        }
      },
      {
        local: require.resolve('generator-react-webpack'),
        link: 'strong'
      }
    ).on('end', () => {

      // Run the create dispatcher method
      this.composeWith('react-webpack-alt:dispatcher', {
        options: {},
        args: ['Dispatcher']
      });

      // Install alt.js and its dependencies as requirement
      this.npmInstall(['alt', 'alt-container'], { save: true });
      this.npmInstall(['alt-utils'], { saveDev: true });
    });
  }
});
